local buttons = {}
local function newButton(x,y,image)
	local button = {
		image = image,
		x = x,
		y = y,
	}
	buttons[#buttons+1] = button
end

function love.load()
	local width,height = love.graphics.getDimensions()
	local image1 = love.graphics.newImage("button.png")
	
	local iWidth,iHeight = image1:getWidth(),image1:getHeight()
	for i=1,100 do
		newButton(math.random(width-iWidth),math.random(height-iHeight),image1)
	end
end

function love.draw()
	for i=1,#buttons do
		local button = buttons[i]
		if (button.selected) then
			love.graphics.setColor(0,255,0,255)
		else
			love.graphics.setColor(255,255,255,255)
		end
		love.graphics.draw(button.image,button.x,button.y)
	end
end

local function getButtonOnPosition(x,y)
	for i=#buttons,1,-1 do
		local button = buttons[i]
		local image = button.image
		local width,height = image:getWidth(),image:getHeight()
		local bx,by = button.x,button.y
		if ((x >= bx) and (y >= by) and (x < bx+width) and (y < by+height)) then
			local imageData = image:getData()
			local r,g,b,a = imageData:getPixel(x-bx,y-by)
			if (r+g+b > 0 and a > 0) then
				return button
			end
		end
	end
end

function love.update(dt)
	for i=1,#buttons do
		local button = buttons[i]
		button.selected = nil
	end

	local button = getButtonOnPosition(love.mouse.getPosition())
	if (button) then
		button.selected = true
	end
end





